#include "Vram.h"
#include "Chars.h"
#include "Movable.h"
#include "Sprite.h"
#include "CopyMemory.h"

extern byte[] MonoPatternSource, ColorPatternSource, SpritePattern;
constexpr byte SourceCharSize = 8 * 3;

byte[48 * Char_End] CharPattern;

void InitVram()
{
    ClearScreen();
    MakePatternMono(Char_Ascii, MonoPatternSource + Char_Ascii * CharHeight, 64, 0x07);
    MakePatternMono(Char_Logo, MonoPatternSource + Char_Logo * CharHeight, 16, 0x05);
    MakePatternMono(Char_Fence, MonoPatternSource + Char_Fence * CharHeight, 2, 0x01);
    MakePatternColor(Char_Wall, ColorPatternSource, Char_End - Char_Wall);
}


void DrawAll()
{
    EraseSprites();
    VVramToVram();
    DrawSprites();
    SwapVram();
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


void Put2(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
}

void Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - 2 * VramStep;
    }
}

// void Put4(word vram, ptr<byte> pBytes)
// {
//     repeat(4) {
//         repeat(4) {
//             Put(vram, *pBytes);
//             ++pBytes;
//             vram += VramStep;
//         }
//         vram += VramRowSize - 4 * VramStep;
//     }
// }